﻿using System;
using System.Collections.Generic;
using System.Windows;

namespace AirFusionCustomNotification
{
	class CustomNotificationModel
	{
		#region ==================== Members ====================

		private int i = 1;

		#endregion

		#region ==================== Constructors ====================

		public CustomNotificationModel()
		{

		}

		#endregion

		#region ==================== Events & Event Arguments ====================

		public class QuickActionTriggeredEventArgs : EventArgs
		{
			public int QuickActionId { get; internal set; }
		}

		private delegate void QuickActionTriggeredEventHandler(object sender, QuickActionTriggeredEventArgs args);

		/// <summary>
		/// Triggered when the custom notification is being clicked
		/// </summary>
		private event QuickActionTriggeredEventHandler QuickActionTriggered;

		#endregion

		#region ==================== Methods ====================

		public void CreatCustomNotification()
		{
			List<CustomNotificationViewModel.DynamicButtonStruct> _dynamicButtonsList = new List<CustomNotificationViewModel.DynamicButtonStruct>();

			System.Windows.Application.Current.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.Normal, new Action(() =>
			{
				CustomNotificationViewModel _cNViewModel = new CustomNotificationViewModel();
				CustomNotificationViewModel.CustomNotificationElement _cNElement = new CustomNotificationViewModel.CustomNotificationElement
				{
					NotificationWidth = "360",
					NotificationHeight = "120",
					NotificationIcon = null,
					NotificationTitle = "NotificationTitle " + i.ToString(),
					NotificationContent = "NotificationContent " + i.ToString(),
					NotificationInfomation = "NotificationInfomation " + i.ToString(),
					TimeToCloseNotification = "0:0:4",
					NotificationKey = "NotificationKey " + i.ToString(),
					_dynamicButtonsList = _dynamicButtonsList,
				};

				_cNViewModel.CreatCustomNotification(_cNElement);
			}));

			i++;
		}

		private void ShowMessageBox()
		{
			MessageBox.Show("111");
		}

		#endregion
	}
}
