﻿using AirFusion;
using AirFusion.Common;
using AirFusion.Manager;
using AirFusion.Manager.DeviceManager;
using AirFusion.WebService;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace AirFusion
{
	/// <summary>
	/// Interaction logic for AutoLoginDlg.xaml
	/// </summary>
	public partial class AutoLoginDlg : UserControl
	{
		#region Events

		public event EventHandler<UserControlEventArgs> UserControlEvent;

		#endregion Events

		#region Properties

		private AppDeviceInfo _targetDeviceInfo = null;

		public AppDeviceInfo TargetDeviceInfo
		{
			get
			{
				return _targetDeviceInfo;
			}

			set
			{
				_targetDeviceInfo = value;
			}
		}

		private UserControlEventType _commandType = UserControlEventType.None;

		public UserControlEventType CommandType
		{
			get
			{
				return _commandType;
			}

			set
			{
				_commandType = value;
			}
		}

		#endregion Properties

		#region Constructor & Dispose

		public AutoLoginDlg()
		{
			InitializeComponent();
		}

		#endregion Constructor & Dispose

		#region Private Methods

		private void ResetMessage()
		{
			this.CommandType = UserControlEventType.None;
			this.TargetDeviceInfo = null;
			//this.imgPresent.Source = null;
			//this.txtDialogTitle.Text = string.Empty;
			//this.txtDialogDetail.Text = string.Empty;
			//this.txtDialogAccount.Text = string.Empty;
			//this.pwdbPassword.Password = string.Empty;
			//this.pwdbConfirmPassword.Password = string.Empty;
		}

		#endregion Private Methods

		#region UI Event Callbacks

		private void btnLeft_Click(object sender, RoutedEventArgs e)
		{
			// To determine password and confirm password are the same
			//if (this.pwdbConfirmPassword.Password.Equals(this.pwdbPassword.Password))
			//{
			//	object[] metadata = new object[2];
			//	metadata[0] = true;
			//	metadata[1] = this.pwdbConfirmPassword.Password;

			//	if (null != this.UserControlEvent)
			//	{
			//		this.UserControlEvent(this, new UserControlEventArgs(this.CommandType, _targetDeviceInfo, metadata));
			//	}
			//}
			//else
			//{
			//	// To show warning message for different password
			//	if (null != this.UserControlEvent)
			//	{
			//		this.UserControlEvent(this, new UserControlEventArgs(this.CommandType, _targetDeviceInfo, null));
			//	}
			//}

			//this.ResetMessage();
		}

		private void btnRight_Click(object sender, RoutedEventArgs e)
		{
			//object[] metadata = new object[2];
			//metadata[0] = false;
			//metadata[1] = this.pwdbConfirmPassword.Password;

			//if (null != this.UserControlEvent)
			//{
			//	this.UserControlEvent(this, new UserControlEventArgs(this.CommandType, _targetDeviceInfo, metadata));
			//}

			//this.ResetMessage();
		}

		#endregion UI Event Callbacks
	}
}